/* Autogenerated by cpybuilder */
#include <Python.h>
#include "gcc-python.h"
#include "gcc-python-wrappers.h"
#include "gcc-plugin.h"
#include "gcc-c-api/gcc-location.h"

/**** Prototypes ****/


/**** Definitions ****/


static PyObject *
PyGccLocation_get_file(struct PyGccLocation *self, void *closure)
{
    const char *filename = gcc_location_get_filename(self->loc);
    if (!filename) {
      Py_RETURN_NONE;
    }
    return PyGccString_FromString(filename);
}

static PyObject *
PyGccLocation_get_line(struct PyGccLocation *self, void *closure)
{
    return PyGccInt_FromLong(gcc_location_get_line(self->loc));
}

static PyObject *
PyGccLocation_get_column(struct PyGccLocation *self, void *closure)
{
    return PyGccInt_FromLong(gcc_location_get_column(self->loc));
}

static PyObject *
PyGccLocation_get_caret(struct PyGccLocation *self, void *closure)
{
    return PyGccLocation_New(gcc_location_get_caret(self->loc));
}

static PyObject *
PyGccLocation_get_start(struct PyGccLocation *self, void *closure)
{
    return PyGccLocation_New(gcc_location_get_start(self->loc));
}

static PyObject *
PyGccLocation_get_finish(struct PyGccLocation *self, void *closure)
{
    return PyGccLocation_New(gcc_location_get_finish(self->loc));
}
static PyObject *
PyGccLocation_get_in_system_header(PyGccLocation *self, void *closure)
{
    return PyBool_FromLong(gcc_location_get_in_system_header(self->loc));
}

static PyGetSetDef PyGccLocation_getset_table[] = {
    {(char*)"file",
     (getter)PyGccLocation_get_file,
     (setter)NULL,
     (char*)"Name of the source file",
     NULL},
    {(char*)"line",
     (getter)PyGccLocation_get_line,
     (setter)NULL,
     (char*)"Line number within source file",
     NULL},
    {(char*)"column",
     (getter)PyGccLocation_get_column,
     (setter)NULL,
     (char*)"Column number within source file",
     NULL},
    {(char*)"caret",
     (getter)PyGccLocation_get_caret,
     (setter)NULL,
     (char*)"Location of caret",
     NULL},
    {(char*)"start",
     (getter)PyGccLocation_get_start,
     (setter)NULL,
     (char*)"Starting location of range",
     NULL},
    {(char*)"finish",
     (getter)PyGccLocation_get_finish,
     (setter)NULL,
     (char*)"End location of range",
     NULL},
    {(char*)"in_system_header",
     (getter)PyGccLocation_get_in_system_header,
     (setter)NULL,
     (char*)"Boolean: is this location within a system header?",
     NULL},
    {NULL}  /* Sentinel */
};
static PyMethodDef PyGccLocation_methods[] = {
    {(char*)"offset_column",  (PyCFunction)PyGccLocation_offset_column, METH_VARARGS,
     (char*)""},
    {NULL, NULL, 0, NULL} /* Sentinel */
};

PyGccWrapperTypeObject PyGccLocation_TypeObj = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMeta_TypeObj, 0)
            "gcc.Location", /*tp_name*/
            sizeof(PyGccLocation), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = PyGccWrapper_Dealloc,
        #if PY_VERSION_HEX >= 0x03080000
            0, /*tp_vectorcall_offset*/
        #else
            .tp_print = NULL,
        #endif
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = (reprfunc)PyGccLocation_repr,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = (hashfunc)PyGccLocation_hash,
            .tp_call = NULL,
            .tp_str = (reprfunc)PyGccLocation_str,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = PyGccLocation_richcompare,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = PyGccLocation_methods,
            .tp_members = NULL,
            .tp_getset = PyGccLocation_getset_table,
            .tp_base = (PyTypeObject*)NULL,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)(initproc)PyGccLocation_init,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)PyGcc_WrtpMarkForPyGccLocation,
};

static PyMethodDef PyGccRichLocation_methods[] = {
    {(char*)"add_fixit_replace",  (PyCFunction)PyGccRichLocation_add_fixit_replace, METH_VARARGS | METH_KEYWORDS,
     (char*)"FIXME"},
    {NULL, NULL, 0, NULL} /* Sentinel */
};

PyGccWrapperTypeObject PyGccRichLocation_TypeObj = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMeta_TypeObj, 0)
            "gcc.RichLocation", /*tp_name*/
            sizeof(PyGccRichLocation), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = PyGccWrapper_Dealloc,
        #if PY_VERSION_HEX >= 0x03080000
            0, /*tp_vectorcall_offset*/
        #else
            .tp_print = NULL,
        #endif
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = PyGccRichLocation_methods,
            .tp_members = NULL,
            .tp_getset = NULL,
            .tp_base = (PyTypeObject*)NULL,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)(initproc)PyGccRichLocation_init,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)PyGcc_WrtpMarkForPyGccRichLocation,
};


int autogenerated_location_init_types(void)
{
    if (PyType_Ready((PyTypeObject*)&PyGccLocation_TypeObj) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&PyGccRichLocation_TypeObj) < 0)
        goto error;


    return 1;

error:
    return 0;
}

void autogenerated_location_add_types(PyObject *m)
{
    Py_INCREF(&PyGccLocation_TypeObj);
    PyModule_AddObject(m, "Location", (PyObject *)&PyGccLocation_TypeObj);

    Py_INCREF(&PyGccRichLocation_TypeObj);
    PyModule_AddObject(m, "RichLocation", (PyObject *)&PyGccRichLocation_TypeObj);


}

