/* Autogenerated by cpybuilder */
#include <Python.h>
#include "gcc-python.h"
#include "gcc-python-wrappers.h"
#include "gcc-plugin.h"
#include "tree-pass.h"

/**** Prototypes ****/


/**** Definitions ****/

static PyObject *
PyGccPass_get_name(PyGccPass *self, void *closure)
{
    return PyGccString_FromString(self->pass->name);
}

static PyObject *
PyGccPass_get_next(PyGccPass *self, void *closure)
{
    return PyGccPass_New(self->pass->next);
}

static PyObject *
PyGccPass_get_sub(PyGccPass *self, void *closure)
{
    return PyGccPass_New(self->pass->sub);
}

static PyObject *
PyGccPass_get_properties_required(PyGccPass *self, void *closure)
{
    return PyGccInt_FromLong(self->pass->properties_required);
}

static PyObject *
PyGccPass_get_properties_provided(PyGccPass *self, void *closure)
{
    return PyGccInt_FromLong(self->pass->properties_provided);
}

static PyObject *
PyGccPass_get_properties_destroyed(PyGccPass *self, void *closure)
{
    return PyGccInt_FromLong(self->pass->properties_destroyed);
}

static PyObject *
PyGccPass_get_static_pass_number(PyGccPass *self, void *closure)
{
    return PyGccInt_FromLong(self->pass->static_pass_number);
}

static PyGetSetDef PyGccPass_getset_table[] = {
    {(char*)"name",
     (getter)PyGccPass_get_name,
     (setter)NULL,
     (char*)"Name of the pass",
     NULL},
    {(char*)"next",
     (getter)PyGccPass_get_next,
     (setter)NULL,
     (char*)"The next gcc.Pass after this one, or None",
     NULL},
    {(char*)"sub",
     (getter)PyGccPass_get_sub,
     (setter)NULL,
     (char*)"The first sub-pass (gated by this pass' predicate, if any)",
     NULL},
    {(char*)"properties_required",
     (getter)PyGccPass_get_properties_required,
     (setter)NULL,
     (char*)"NULL",
     NULL},
    {(char*)"properties_provided",
     (getter)PyGccPass_get_properties_provided,
     (setter)NULL,
     (char*)"NULL",
     NULL},
    {(char*)"properties_destroyed",
     (getter)PyGccPass_get_properties_destroyed,
     (setter)NULL,
     (char*)"NULL",
     NULL},
    {(char*)"static_pass_number",
     (getter)PyGccPass_get_static_pass_number,
     (setter)NULL,
     (char*)"Number of this pass, used as a fragment of the dump file name",
     NULL},
    {(char*)"dump_enabled",
     (getter)PyGccPass_get_dump_enabled,
     (setter)PyGccPass_set_dump_enabled,
     (char*)"(boolean) Is dumping enabled for this pass?",
     NULL},
    {NULL}  /* Sentinel */
};
static PyMethodDef PyGccPass_methods[] = {
    {(char*)"get_roots",  PyGccPass_get_roots, METH_CLASS | METH_VARARGS,
     (char*)"Get a tuple of gcc.Pass instances, the roots of the compilation pass tree"},
    {(char*)"get_by_name",  (PyCFunction)PyGccPass_get_by_name, METH_CLASS | METH_VARARGS | METH_KEYWORDS,
     (char*)"Get the gcc.Pass instance for the pass with the given name, raising ValueError if it isn't found"},
    {(char*)"register_after",  (PyCFunction)PyGccPass_register_after, METH_VARARGS | METH_KEYWORDS,
     (char*)"Given the name of another pass, register this gcc.Pass to occur immediately after that other pass"},
    {(char*)"register_before",  (PyCFunction)PyGccPass_register_before, METH_VARARGS | METH_KEYWORDS,
     (char*)"Given the name of another pass, register this gcc.Pass to occur immediately before that other pass"},
    {(char*)"replace",  (PyCFunction)PyGccPass_replace, METH_VARARGS | METH_KEYWORDS,
     (char*)"Given the name of another pass, replace that pass with this gcc.Pass"},
    {NULL, NULL, 0, NULL} /* Sentinel */
};

PyGccWrapperTypeObject PyGccPass_TypeObj = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMeta_TypeObj, 0)
            "gcc.Pass", /*tp_name*/
            sizeof(PyGccPass), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = PyGccWrapper_Dealloc,
        #if PY_VERSION_HEX >= 0x03080000
            0, /*tp_vectorcall_offset*/
        #else
            .tp_print = NULL,
        #endif
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = (reprfunc)PyGccPass_repr,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = (reprfunc)PyGccPass_repr,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = (Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE),
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = PyGccPass_methods,
            .tp_members = NULL,
            .tp_getset = PyGccPass_getset_table,
            .tp_base = (PyTypeObject*)NULL,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)PyGcc_WrtpMarkForPyGccPass,
};


PyGccWrapperTypeObject PyGccGimplePass_TypeObj = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMeta_TypeObj, 0)
            "gcc.GimplePass", /*tp_name*/
            sizeof(PyGccPass), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = PyGccWrapper_Dealloc,
        #if PY_VERSION_HEX >= 0x03080000
            0, /*tp_vectorcall_offset*/
        #else
            .tp_print = NULL,
        #endif
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = (Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE),
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = NULL,
            .tp_base = (PyTypeObject*)&PyGccPass_TypeObj,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)PyGccGimplePass_init,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)PyGcc_WrtpMarkForPyGccPass,
};


PyGccWrapperTypeObject PyGccRtlPass_TypeObj = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMeta_TypeObj, 0)
            "gcc.RtlPass", /*tp_name*/
            sizeof(PyGccPass), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = PyGccWrapper_Dealloc,
        #if PY_VERSION_HEX >= 0x03080000
            0, /*tp_vectorcall_offset*/
        #else
            .tp_print = NULL,
        #endif
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = (Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE),
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = NULL,
            .tp_base = (PyTypeObject*)&PyGccPass_TypeObj,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)PyGccRtlPass_init,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)PyGcc_WrtpMarkForPyGccPass,
};


PyGccWrapperTypeObject PyGccSimpleIpaPass_TypeObj = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMeta_TypeObj, 0)
            "gcc.SimpleIpaPass", /*tp_name*/
            sizeof(PyGccPass), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = PyGccWrapper_Dealloc,
        #if PY_VERSION_HEX >= 0x03080000
            0, /*tp_vectorcall_offset*/
        #else
            .tp_print = NULL,
        #endif
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = (Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE),
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = NULL,
            .tp_base = (PyTypeObject*)&PyGccPass_TypeObj,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)PyGccSimpleIpaPass_init,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)PyGcc_WrtpMarkForPyGccPass,
};


PyGccWrapperTypeObject PyGccIpaPass_TypeObj = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMeta_TypeObj, 0)
            "gcc.IpaPass", /*tp_name*/
            sizeof(PyGccPass), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = PyGccWrapper_Dealloc,
        #if PY_VERSION_HEX >= 0x03080000
            0, /*tp_vectorcall_offset*/
        #else
            .tp_print = NULL,
        #endif
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = (Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE),
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = NULL,
            .tp_base = (PyTypeObject*)&PyGccPass_TypeObj,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)PyGccIpaPass_init,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)PyGcc_WrtpMarkForPyGccPass,
};


int autogenerated_pass_init_types(void)
{
    if (PyType_Ready((PyTypeObject*)&PyGccPass_TypeObj) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&PyGccGimplePass_TypeObj) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&PyGccRtlPass_TypeObj) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&PyGccSimpleIpaPass_TypeObj) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&PyGccIpaPass_TypeObj) < 0)
        goto error;


    return 1;

error:
    return 0;
}

void autogenerated_pass_add_types(PyObject *m)
{
    Py_INCREF(&PyGccPass_TypeObj);
    PyModule_AddObject(m, "Pass", (PyObject *)&PyGccPass_TypeObj);

    Py_INCREF(&PyGccGimplePass_TypeObj);
    PyModule_AddObject(m, "GimplePass", (PyObject *)&PyGccGimplePass_TypeObj);

    Py_INCREF(&PyGccRtlPass_TypeObj);
    PyModule_AddObject(m, "RtlPass", (PyObject *)&PyGccRtlPass_TypeObj);

    Py_INCREF(&PyGccSimpleIpaPass_TypeObj);
    PyModule_AddObject(m, "SimpleIpaPass", (PyObject *)&PyGccSimpleIpaPass_TypeObj);

    Py_INCREF(&PyGccIpaPass_TypeObj);
    PyModule_AddObject(m, "IpaPass", (PyObject *)&PyGccIpaPass_TypeObj);


}

