/* This file is autogenerated: do not edit */
/*
   Copyright 2013 David Malcolm <dmalcolm@redhat.com>
   Copyright 2013 Red Hat, Inc.

   This is free software: you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see
   <http://www.gnu.org/licenses/>.
*/

#include "gcc-common.h"

#ifdef __cplusplus
extern "C" {
#endif
/*
  Callgraphs
*/

/* gcc_cgraph_node */

GCC_PUBLIC_API(void)
gcc_cgraph_node_mark_in_use(gcc_cgraph_node node);

/*
  The function declaration for this node within the callgraph
*/
GCC_PUBLIC_API(gcc_function_decl)
gcc_cgraph_node_get_decl(gcc_cgraph_node node);

/*
  Iterator; terminates if the callback returns truth
  (for linear search)
*/
GCC_PUBLIC_API(bool)
gcc_cgraph_node_for_each_callee(gcc_cgraph_node node,
    bool (*cb)(gcc_cgraph_edge edge, void *user_data),
    void *user_data);

/*
  Iterator; terminates if the callback returns truth
  (for linear search)
*/
GCC_PUBLIC_API(bool)
gcc_cgraph_node_for_each_caller(gcc_cgraph_node node,
    bool (*cb)(gcc_cgraph_edge edge, void *user_data),
    void *user_data);

/* gcc_cgraph_edge */

/*
  An edge within the callgraph
*/
GCC_PUBLIC_API(void)
gcc_cgraph_edge_mark_in_use(gcc_cgraph_edge edge);

/*
  The function that makes this call
*/
GCC_PUBLIC_API(gcc_cgraph_node)
gcc_cgraph_edge_get_caller(gcc_cgraph_edge edge);

/*
  The function that is called here
*/
GCC_PUBLIC_API(gcc_cgraph_node)
gcc_cgraph_edge_get_callee(gcc_cgraph_edge edge);

/*
  The gimple call statement representing the function call
*/
GCC_PUBLIC_API(gcc_gimple_call)
gcc_cgraph_edge_get_call_stmt(gcc_cgraph_edge edge);

/*
    Iterator; terminates if the callback returns truth
    (for linear search).
*/
GCC_PUBLIC_API(bool)
gcc_for_each_cgraph_node(bool (*cb)(gcc_cgraph_node node, void *user_data),
    void *user_data);

#ifdef __cplusplus
}
#endif

/*
  PEP-7
Local variables:
c-basic-offset: 4
indent-tabs-mode: nil
End:
*/
