/* This file is autogenerated: do not edit */
/*
   Copyright 2013 David Malcolm <dmalcolm@redhat.com>
   Copyright 2013 Red Hat, Inc.

   This is free software: you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see
   <http://www.gnu.org/licenses/>.
*/

#include "gcc-common.h"

#ifdef __cplusplus
extern "C" {
#endif
/*
  GIMPLE statements
*/

/* gcc_gimple */

GCC_PUBLIC_API(void)
gcc_gimple_mark_in_use(gcc_gimple stmt);

/*
  Source code location of this statement
*/
GCC_PUBLIC_API(gcc_location)
gcc_gimple_get_location(gcc_gimple stmt);

/*
  The lexical block holding this statement, as a gcc_tree
*/
GCC_PUBLIC_API(gcc_tree)
gcc_gimple_get_block(gcc_gimple stmt);

/*
  The type of the main expression computed by this statement, as a gcc_tree (which might be void_type.
*/
GCC_PUBLIC_API(gcc_tree)
gcc_gimple_get_expr_type(gcc_gimple stmt);

GCC_PUBLIC_API(gcc_gimple_asm)
gcc_gimple_as_gcc_gimple_asm(gcc_gimple stmt);

GCC_PUBLIC_API(gcc_gimple_assign)
gcc_gimple_as_gcc_gimple_assign(gcc_gimple stmt);

GCC_PUBLIC_API(gcc_gimple_call)
gcc_gimple_as_gcc_gimple_call(gcc_gimple stmt);

GCC_PUBLIC_API(gcc_gimple_return)
gcc_gimple_as_gcc_gimple_return(gcc_gimple stmt);

GCC_PUBLIC_API(gcc_gimple_cond)
gcc_gimple_as_gcc_gimple_cond(gcc_gimple stmt);

GCC_PUBLIC_API(gcc_gimple_phi)
gcc_gimple_as_gcc_gimple_phi(gcc_gimple stmt);

GCC_PUBLIC_API(gcc_gimple_switch)
gcc_gimple_as_gcc_gimple_switch(gcc_gimple stmt);

GCC_PUBLIC_API(gcc_gimple_label)
gcc_gimple_as_gcc_gimple_label(gcc_gimple stmt);

/* gcc_gimple_asm */

GCC_PUBLIC_API(void)
gcc_gimple_asm_mark_in_use(gcc_gimple_asm stmt);

/*
  The inline assembler as a string
*/
GCC_PUBLIC_API(const char*)
gcc_gimple_asm_get_string(gcc_gimple_asm stmt);

GCC_PUBLIC_API(gcc_gimple)
gcc_gimple_asm_as_gcc_gimple(gcc_gimple_asm stmt);

/* gcc_gimple_assign */

GCC_PUBLIC_API(void)
gcc_gimple_assign_mark_in_use(gcc_gimple_assign stmt);

/*
  The left-hand-side of the assignment
*/
GCC_PUBLIC_API(gcc_tree)
gcc_gimple_assign_get_lhs(gcc_gimple_assign stmt);

GCC_PUBLIC_API(gcc_gimple)
gcc_gimple_assign_as_gcc_gimple(gcc_gimple_assign stmt);

/* gcc_gimple_call */

GCC_PUBLIC_API(void)
gcc_gimple_call_mark_in_use(gcc_gimple_call stmt);

/*
  The left-hand-side of the call
*/
GCC_PUBLIC_API(gcc_tree)
gcc_gimple_call_get_lhs(gcc_gimple_call stmt);

/*
  The function being called
*/
GCC_PUBLIC_API(gcc_tree)
gcc_gimple_call_get_fn(gcc_gimple_call stmt);

/*
  The declaration of the function being called (if any)
*/
GCC_PUBLIC_API(gcc_tree)
gcc_gimple_call_get_fndecl(gcc_gimple_call stmt);

/*
  Has this call been marked as never returning?
*/
GCC_PUBLIC_API(bool)
gcc_gimple_call_is_noreturn(gcc_gimple_call stmt);

/*
  Iterator; terminates if the callback returns truth
  (for linear search)
*/
GCC_PUBLIC_API(bool)
gcc_gimple_call_for_each_arg(gcc_gimple_call stmt,
    bool (*cb)(gcc_tree node, void *user_data),
    void *user_data);

GCC_PUBLIC_API(gcc_gimple)
gcc_gimple_call_as_gcc_gimple(gcc_gimple_call stmt);

/* gcc_gimple_return */

GCC_PUBLIC_API(void)
gcc_gimple_return_mark_in_use(gcc_gimple_return stmt);

/*
  The return value
*/
GCC_PUBLIC_API(gcc_tree)
gcc_gimple_return_get_retval(gcc_gimple_return stmt);

GCC_PUBLIC_API(gcc_gimple)
gcc_gimple_return_as_gcc_gimple(gcc_gimple_return stmt);

/* gcc_gimple_cond */

GCC_PUBLIC_API(void)
gcc_gimple_cond_mark_in_use(gcc_gimple_cond stmt);

GCC_PUBLIC_API(gcc_tree)
gcc_gimple_cond_get_lhs(gcc_gimple_cond stmt);

GCC_PUBLIC_API(gcc_tree)
gcc_gimple_cond_get_rhs(gcc_gimple_cond stmt);

GCC_PUBLIC_API(gcc_tree)
gcc_gimple_cond_get_true_label(gcc_gimple_cond stmt);

GCC_PUBLIC_API(gcc_tree)
gcc_gimple_cond_get_false_label(gcc_gimple_cond stmt);

GCC_PUBLIC_API(gcc_gimple)
gcc_gimple_cond_as_gcc_gimple(gcc_gimple_cond stmt);

/* gcc_gimple_phi */

GCC_PUBLIC_API(void)
gcc_gimple_phi_mark_in_use(gcc_gimple_phi phi);

/*
  The left-hand-side of the call
*/
GCC_PUBLIC_API(gcc_tree)
gcc_gimple_phi_get_lhs(gcc_gimple_phi phi);

GCC_PUBLIC_API(gcc_tree)
gcc_gimple_phi_get_result(gcc_gimple_phi phi);

/*
  Iterator; terminates if the callback returns truth
  (for linear search)
*/
GCC_PUBLIC_API(bool)
gcc_gimple_phi_for_each_exprs(gcc_gimple_phi phi,
    bool (*cb)(gcc_tree node, void *user_data),
    void *user_data);

/*
  Iterator; terminates if the callback returns truth
  (for linear search)
*/
GCC_PUBLIC_API(bool)
gcc_gimple_phi_for_each_edges(gcc_gimple_phi phi,
    bool (*cb)(gcc_cfg_edge edge, void *user_data),
    void *user_data);

GCC_PUBLIC_API(gcc_gimple)
gcc_gimple_phi_as_gcc_gimple(gcc_gimple_phi phi);

/* gcc_gimple_switch */

GCC_PUBLIC_API(void)
gcc_gimple_switch_mark_in_use(gcc_gimple_switch stmt);

/*
  The index variable used by the switch statement
*/
GCC_PUBLIC_API(gcc_tree)
gcc_gimple_switch_get_indexvar(gcc_gimple_switch stmt);

/*
  Iterator; terminates if the callback returns truth
  (for linear search)
*/
GCC_PUBLIC_API(bool)
gcc_gimple_switch_for_each_label(gcc_gimple_switch stmt,
    bool (*cb)(gcc_case_label_expr node, void *user_data),
    void *user_data);

GCC_PUBLIC_API(gcc_gimple)
gcc_gimple_switch_as_gcc_gimple(gcc_gimple_switch stmt);

/* gcc_gimple_label */

GCC_PUBLIC_API(void)
gcc_gimple_label_mark_in_use(gcc_gimple_label stmt);

/*
  The underlying label_decl for this statement
*/
GCC_PUBLIC_API(gcc_label_decl)
gcc_gimple_label_get_label(gcc_gimple_label stmt);

GCC_PUBLIC_API(gcc_gimple)
gcc_gimple_label_as_gcc_gimple(gcc_gimple_label stmt);

#ifdef __cplusplus
}
#endif

/*
  PEP-7
Local variables:
c-basic-offset: 4
indent-tabs-mode: nil
End:
*/
