/* This file is autogenerated: do not edit */
/*
   Copyright 2013 David Malcolm <dmalcolm@redhat.com>
   Copyright 2013 Red Hat, Inc.

   This is free software: you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see
   <http://www.gnu.org/licenses/>.
*/

#ifndef INCLUDED__GCC_SEMIPRIVATE_TYPES_H
#define INCLUDED__GCC_SEMIPRIVATE_TYPES_H

#include "input.h" /* for location_t */
#include "options.h" /* for enum opt_code */

#ifdef __cplusplus
extern "C" {
#endif
/*
  These "interface types" should be treated like pointers, only that
  users are required to collaborate with the garbage-collector.

  The internal details are exposed here so that the debugger is able to
  identify the real types.  Plugin developers should *not* rely on the
  internal implementation details.

  By being structs, the compiler will be able to complain if plugin code
  directly pokes at a pointer.
*/
/* Semiprivate types: Callgraphs */
struct gcc_cgraph_node {
  struct cgraph_node * inner;
};

GCC_PRIVATE_API(struct gcc_cgraph_node)
gcc_private_make_cgraph_node(struct cgraph_node * inner);

struct gcc_cgraph_edge {
  struct cgraph_edge * inner;
};

GCC_PRIVATE_API(struct gcc_cgraph_edge)
gcc_private_make_cgraph_edge(struct cgraph_edge * inner);

/* Semiprivate types: Control Flow Graphs */
struct gcc_cfg {
  struct control_flow_graph * inner;
};

GCC_PRIVATE_API(struct gcc_cfg)
gcc_private_make_cfg(struct control_flow_graph * inner);

struct gcc_cfg_block {
  basic_block inner;
};

GCC_PRIVATE_API(struct gcc_cfg_block)
gcc_private_make_cfg_block(basic_block inner);

struct gcc_cfg_edge {
  edge inner;
};

GCC_PRIVATE_API(struct gcc_cfg_edge)
gcc_private_make_cfg_edge(edge inner);

/* Semiprivate types: Constant Expressions */
struct gcc_constant {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_constant)
gcc_private_make_constant(tree inner);

struct gcc_complex_constant {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_complex_constant)
gcc_private_make_complex_constant(tree inner);

struct gcc_fixed_constant {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_fixed_constant)
gcc_private_make_fixed_constant(tree inner);

struct gcc_integer_constant {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_integer_constant)
gcc_private_make_integer_constant(tree inner);

struct gcc_ptrmem_constant {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_ptrmem_constant)
gcc_private_make_ptrmem_constant(tree inner);

struct gcc_real_constant {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_real_constant)
gcc_private_make_real_constant(tree inner);

struct gcc_string_constant {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_string_constant)
gcc_private_make_string_constant(tree inner);

struct gcc_vector_constant {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_vector_constant)
gcc_private_make_vector_constant(tree inner);

/* Semiprivate types: Declarations */
struct gcc_decl {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_decl)
gcc_private_make_decl(tree inner);

struct gcc_class_method_decl {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_class_method_decl)
gcc_private_make_class_method_decl(tree inner);

struct gcc_const_decl {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_const_decl)
gcc_private_make_const_decl(tree inner);

struct gcc_debug_expr_decl {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_debug_expr_decl)
gcc_private_make_debug_expr_decl(tree inner);

struct gcc_field_decl {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_field_decl)
gcc_private_make_field_decl(tree inner);

struct gcc_function_decl {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_function_decl)
gcc_private_make_function_decl(tree inner);

struct gcc_imported_decl {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_imported_decl)
gcc_private_make_imported_decl(tree inner);

struct gcc_instance_method_decl {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_instance_method_decl)
gcc_private_make_instance_method_decl(tree inner);

struct gcc_keyword_decl {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_keyword_decl)
gcc_private_make_keyword_decl(tree inner);

struct gcc_label_decl {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_label_decl)
gcc_private_make_label_decl(tree inner);

struct gcc_namespace_decl {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_namespace_decl)
gcc_private_make_namespace_decl(tree inner);

struct gcc_parm_decl {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_parm_decl)
gcc_private_make_parm_decl(tree inner);

struct gcc_property_decl {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_property_decl)
gcc_private_make_property_decl(tree inner);

struct gcc_result_decl {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_result_decl)
gcc_private_make_result_decl(tree inner);

struct gcc_template_decl {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_template_decl)
gcc_private_make_template_decl(tree inner);

struct gcc_translation_unit_decl {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_translation_unit_decl)
gcc_private_make_translation_unit_decl(tree inner);

struct gcc_type_decl {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_type_decl)
gcc_private_make_type_decl(tree inner);

struct gcc_using_decl {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_using_decl)
gcc_private_make_using_decl(tree inner);

struct gcc_var_decl {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_var_decl)
gcc_private_make_var_decl(tree inner);

/* Semiprivate types: Diagnostics */
/* Semiprivate types: Functions */
struct gcc_function {
  struct function* inner;
};

GCC_PRIVATE_API(struct gcc_function)
gcc_private_make_function(struct function* inner);

/* Semiprivate types: GIMPLE statements */
struct gcc_gimple {
  gimple_stmt_ptr inner;
};

GCC_PRIVATE_API(struct gcc_gimple)
gcc_private_make_gimple(gimple_stmt_ptr inner);

struct gcc_gimple_asm {
  gimple_stmt_ptr inner;
};

GCC_PRIVATE_API(struct gcc_gimple_asm)
gcc_private_make_gimple_asm(gimple_stmt_ptr inner);

struct gcc_gimple_assign {
  gimple_stmt_ptr inner;
};

GCC_PRIVATE_API(struct gcc_gimple_assign)
gcc_private_make_gimple_assign(gimple_stmt_ptr inner);

struct gcc_gimple_call {
  gimple_stmt_ptr inner;
};

GCC_PRIVATE_API(struct gcc_gimple_call)
gcc_private_make_gimple_call(gimple_stmt_ptr inner);

struct gcc_gimple_return {
  gimple_stmt_ptr inner;
};

GCC_PRIVATE_API(struct gcc_gimple_return)
gcc_private_make_gimple_return(gimple_stmt_ptr inner);

struct gcc_gimple_cond {
  gimple_stmt_ptr inner;
};

GCC_PRIVATE_API(struct gcc_gimple_cond)
gcc_private_make_gimple_cond(gimple_stmt_ptr inner);

struct gcc_gimple_phi {
  gimple_stmt_ptr inner;
};

GCC_PRIVATE_API(struct gcc_gimple_phi)
gcc_private_make_gimple_phi(gimple_stmt_ptr inner);

struct gcc_gimple_switch {
  gimple_stmt_ptr inner;
};

GCC_PRIVATE_API(struct gcc_gimple_switch)
gcc_private_make_gimple_switch(gimple_stmt_ptr inner);

struct gcc_gimple_label {
  gimple_stmt_ptr inner;
};

GCC_PRIVATE_API(struct gcc_gimple_label)
gcc_private_make_gimple_label(gimple_stmt_ptr inner);

/* Semiprivate types: Source code locations */
struct gcc_location {
  location_t inner;
};

GCC_PRIVATE_API(struct gcc_location)
gcc_private_make_location(location_t inner);

/* Semiprivate types: Command-line options */
struct gcc_option {
  enum opt_code inner;
};

GCC_PRIVATE_API(struct gcc_option)
gcc_private_make_option(enum opt_code inner);

/* Semiprivate types: Register Transfer Language */
struct gcc_rtl_insn {
  struct rtx_def * inner;
};

GCC_PRIVATE_API(struct gcc_rtl_insn)
gcc_private_make_rtl_insn(struct rtx_def * inner);

/* Semiprivate types: Trees */
struct gcc_tree {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_tree)
gcc_private_make_tree(tree inner);

struct gcc_binary {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_binary)
gcc_private_make_binary(tree inner);

struct gcc_bitwise_and_expr {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_bitwise_and_expr)
gcc_private_make_bitwise_and_expr(tree inner);

struct gcc_bitwise_ior_expr {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_bitwise_ior_expr)
gcc_private_make_bitwise_ior_expr(tree inner);

struct gcc_bitwise_xor_expr {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_bitwise_xor_expr)
gcc_private_make_bitwise_xor_expr(tree inner);

struct gcc_block {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_block)
gcc_private_make_block(tree inner);

struct gcc_comparison {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_comparison)
gcc_private_make_comparison(tree inner);

struct gcc_constructor {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_constructor)
gcc_private_make_constructor(tree inner);

struct gcc_expression {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_expression)
gcc_private_make_expression(tree inner);

struct gcc_addr_expr {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_addr_expr)
gcc_private_make_addr_expr(tree inner);

struct gcc_reference {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_reference)
gcc_private_make_reference(tree inner);

struct gcc_array_ref {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_array_ref)
gcc_private_make_array_ref(tree inner);

struct gcc_component_ref {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_component_ref)
gcc_private_make_component_ref(tree inner);

struct gcc_mem_ref {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_mem_ref)
gcc_private_make_mem_ref(tree inner);

struct gcc_ssa_name {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_ssa_name)
gcc_private_make_ssa_name(tree inner);

struct gcc_statement {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_statement)
gcc_private_make_statement(tree inner);

struct gcc_case_label_expr {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_case_label_expr)
gcc_private_make_case_label_expr(tree inner);

struct gcc_unary {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_unary)
gcc_private_make_unary(tree inner);

struct gcc_vlexp {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_vlexp)
gcc_private_make_vlexp(tree inner);

/* Semiprivate types: Types */
struct gcc_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_type)
gcc_private_make_type(tree inner);

struct gcc_array_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_array_type)
gcc_private_make_array_type(tree inner);

struct gcc_boolean_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_boolean_type)
gcc_private_make_boolean_type(tree inner);

struct gcc_bound_template_template_parm {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_bound_template_template_parm)
gcc_private_make_bound_template_template_parm(tree inner);

struct gcc_category_implementation_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_category_implementation_type)
gcc_private_make_category_implementation_type(tree inner);

struct gcc_category_interface_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_category_interface_type)
gcc_private_make_category_interface_type(tree inner);

struct gcc_class_implementation_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_class_implementation_type)
gcc_private_make_class_implementation_type(tree inner);

struct gcc_class_interface_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_class_interface_type)
gcc_private_make_class_interface_type(tree inner);

struct gcc_complex_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_complex_type)
gcc_private_make_complex_type(tree inner);

struct gcc_decl_type_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_decl_type_type)
gcc_private_make_decl_type_type(tree inner);

struct gcc_enumeral_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_enumeral_type)
gcc_private_make_enumeral_type(tree inner);

struct gcc_fixed_point_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_fixed_point_type)
gcc_private_make_fixed_point_type(tree inner);

struct gcc_function_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_function_type)
gcc_private_make_function_type(tree inner);

struct gcc_integer_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_integer_type)
gcc_private_make_integer_type(tree inner);

struct gcc_lang_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_lang_type)
gcc_private_make_lang_type(tree inner);

struct gcc_method_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_method_type)
gcc_private_make_method_type(tree inner);

struct gcc_null_ptr_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_null_ptr_type)
gcc_private_make_null_ptr_type(tree inner);

struct gcc_offset_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_offset_type)
gcc_private_make_offset_type(tree inner);

struct gcc_pointer_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_pointer_type)
gcc_private_make_pointer_type(tree inner);

struct gcc_protocol_interface_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_protocol_interface_type)
gcc_private_make_protocol_interface_type(tree inner);

struct gcc_qual_union_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_qual_union_type)
gcc_private_make_qual_union_type(tree inner);

struct gcc_real_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_real_type)
gcc_private_make_real_type(tree inner);

struct gcc_record_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_record_type)
gcc_private_make_record_type(tree inner);

struct gcc_reference_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_reference_type)
gcc_private_make_reference_type(tree inner);

struct gcc_template_template_parm {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_template_template_parm)
gcc_private_make_template_template_parm(tree inner);

struct gcc_template_type_parm {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_template_type_parm)
gcc_private_make_template_type_parm(tree inner);

struct gcc_type_argument_pack {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_type_argument_pack)
gcc_private_make_type_argument_pack(tree inner);

struct gcc_type_pack_expansion {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_type_pack_expansion)
gcc_private_make_type_pack_expansion(tree inner);

struct gcc_typename_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_typename_type)
gcc_private_make_typename_type(tree inner);

struct gcc_typeof_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_typeof_type)
gcc_private_make_typeof_type(tree inner);

struct gcc_unbound_class_template {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_unbound_class_template)
gcc_private_make_unbound_class_template(tree inner);

struct gcc_unconstrained_array_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_unconstrained_array_type)
gcc_private_make_unconstrained_array_type(tree inner);

struct gcc_union_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_union_type)
gcc_private_make_union_type(tree inner);

struct gcc_vector_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_vector_type)
gcc_private_make_vector_type(tree inner);

struct gcc_void_type {
  tree inner;
};

GCC_PRIVATE_API(struct gcc_void_type)
gcc_private_make_void_type(tree inner);

/* Semiprivate types: Variables */
struct gcc_variable {
  struct varpool_node * inner;
};

GCC_PRIVATE_API(struct gcc_variable)
gcc_private_make_variable(struct varpool_node * inner);

#ifdef __cplusplus
}
#endif
#endif /* INCLUDED__GCC_SEMIPRIVATE_TYPES_H */

/*
  PEP-7
Local variables:
c-basic-offset: 4
indent-tabs-mode: nil
End:
*/
